<?php

defined( 'ABSPATH' ) or die( 'But why!?' );

function tld_wcdpue_welcome_screen_activate() {
  set_transient( 'tld_wcdpue_welcome_screen_activation_redirect', true, 30 );
}

function tld_wcdpue_welcome_screen_do_activation_redirect() {
  // Bail if no activation redirect
  if ( ! get_transient( 'tld_wcdpue_welcome_screen_activation_redirect' ) || get_option( 'tld_wcdpue_showed_welcome_screen' )  ) {
    return;
  }

  // Delete the redirect transient
  delete_transient( 'tld_wcdpue_welcome_screen_activation_redirect' );

  // Bail if activating from network, or bulk
  if ( is_network_admin() || isset( $_GET['activate-multi'] ) ) {
    return;
  }

  // Redirect to welcome page
  wp_safe_redirect( add_query_arg( array( 'page' => 'tld-wcdpue-welcome-screen-about' ), admin_url( 'index.php' ) ) );

  update_option( 'tld_wcdpue_showed_welcome_screen', true );

}
add_action( 'admin_init', 'tld_wcdpue_welcome_screen_do_activation_redirect' );

function tld_wcdpue_welcome_screen_content() {
  ?>
  <div class="wrap">
    <h2>WooCommerce Downloadable Product Update E-mails</h2>

    <h1>
      Get started quickly with your brand new plugin!
    </h1>

    <h3>Step 1 (Recommended):</h3>
    <p>Read plugin documentation</p>
    <a href="http://uriahsvictor.com/wcdpue-pro-documentation/" class="button button-primary" target="_blank">Documentation</a>
    <br>
    <h3>Step 2 (Recommended):</h3>
    <p>Head over to the plugin settings page to configure your e-mail preferences.</p>
    <a href="<?php menu_page_url('wcdpue-pro') ?>" class="button button-primary" target="_blank">Settings page</a>
    <br>
    <h3>Step 3 (Recommended):</h3>
    <p>We highly recommend that you install and configure Post SMTP for better email dilverability.</p>
    <a href="https://wordpress.org/plugins/post-smtp/" class="button button-primary" target="_blank">Get plugin</a>
    <br>
    <p><strong>Be sure to delete the Lite version of the plugin and all it's settings by select "Delete all plugin settings on uninstall?" on the WCDPUE Lite settings page and then deactivating and deleting it.</strong></p>
  </div>
  <?php
}

function tld_wcdpue_welcome_screen_pages() {
  add_dashboard_page(
    'WCDPUE PRO',
    'WCDPUE PRO Welcome Screen',
    'activate_plugins',
    'tld-wcdpue-welcome-screen-about',//try underscores
    'tld_wcdpue_welcome_screen_content'
  );
}
add_action('admin_menu', 'tld_wcdpue_welcome_screen_pages');

function tld_wcdpue_welcome_screen_remove_menus() {
  remove_submenu_page( 'index.php', 'tld-wcdpue-welcome-screen-about' );
}
add_action( 'admin_head', 'tld_wcdpue_welcome_screen_remove_menus' );
