<?php

defined( 'ABSPATH' ) or die( 'But why!?' );

function tld_wcdpue_activate_schedule(){

  $tld_wcdpue_cur_recurrence = get_option( 'tld_wcdpue_schedule_setting_value' );

  if ( !empty( $tld_wcdpue_cur_recurrence ) ){

    $tld_wcdpue_active_cron_schedules = wp_get_schedules();

    foreach ( $tld_wcdpue_active_cron_schedules as $key => $value ) {

      if ( $key == $tld_wcdpue_cur_recurrence ){

        $tld_wcdpue_wait_time = $value['interval'];

      }

    }

    wp_schedule_event( time() + $tld_wcdpue_wait_time, $tld_wcdpue_cur_recurrence, 'tld_wcdpue_email_burst' );

  }else{

    wp_schedule_event( time(), 'daily', 'tld_wcdpue_email_burst' );
    update_option( 'tld_wcdpue_schedule_setting_value', 'daily' );

  }

}

add_action( 'tld_wcdpue_email_burst', 'tld_wcdpue_send_schedule_mail' );

//scheduled tasks that runs each time cron job runs
function tld_wcdpue_send_schedule_mail(){

  //get our options
  $tld_wcdpue_email_bursts_count = esc_attr( get_option( 'tld_wcdpue_email_bursts_count' ) );
  $tld_wcdpue_account_url = esc_url ( get_permalink( get_option( 'woocommerce_myaccount_page_id' ) ) );

  $tld_wcdpue_account_url_trim  = apply_filters( 'tld_wcdpue_url_trim', $tld_wcdpue_account_url );

  if ( empty( $tld_wcdpue_email_bursts_count ) ){
    $tld_wcdpue_email_bursts_count = 5; //limit number of emails sent per schedule hit to 5
  }

  global $wpdb;
  $tld_wcdpue_the_scheduling_table = TLD_WCDPUE_SCHEDULED_TABLE;

  $tld_wcdpue_query_result = $wpdb->get_results( "SELECT * FROM $tld_wcdpue_the_scheduling_table ORDER BY id ASC LIMIT $tld_wcdpue_email_bursts_count" );
  // $tld_wcdpue_query_result = $wpdb->get_results( "SELECT DISTINCT product_id, product_parent, order_id, order_key, user_email, is_variable, downloads_markup, download_names FROM $tld_wcdpue_the_scheduling_table ORDER BY id ASC LIMIT $tld_wcdpue_email_bursts_count" );

  foreach ( $tld_wcdpue_query_result as $tld_wcdpue_result ){

    $tld_wcdpue_email_subject = get_option( 'tld_wcdpue_email_subject' );

    if ( empty( $tld_wcdpue_email_subject ) ){
      $tld_wcdpue_email_subject = 'A product you bought has been updated!';
    }

// TODO add a way to check if email exists multiple times in db info pull and if so concat all info into body and delete other rows
    $tld_wcdpue_email_body = get_option( 'tld_wcdpue_settings_email_content' );

    if ( empty( $tld_wcdpue_email_body ) ){
      $tld_wcdpue_email_body = 'There is a new update for one of your digital products! Log into your account to download it: ' . $tld_wcdpue_account_url;
    }

    //Product title
    if( !empty( $tld_wcdpue_result->product_parent ) ){
      $tld_wcdpue_product_url = get_permalink( $tld_wcdpue_result->product_parent );
      $tld_wcdpue_product_name = "A variation of " . get_the_title( $tld_wcdpue_result->product_parent );
    }else{
      $tld_wcdpue_product_url = get_permalink( $tld_wcdpue_result->product_id );
      $tld_wcdpue_product_name = get_the_title( $tld_wcdpue_result->product_id );
    }

    //Product image
    $tld_wcdpue_product_img = wp_get_attachment_image( get_post_thumbnail_id( ! ( $tld_wcdpue_result->is_variable ) ? $tld_wcdpue_result->product_id : $tld_wcdpue_result->product_parent ), "thumbnail", "", array( "style" => "font-family: Georgia; color: #697c52; font-style: italic; font-size: 20px;" ) );

    //Product URL
    $tld_wcdpue_product_url_trim = apply_filters( 'tld_wcdpue_url_trim', $tld_wcdpue_product_url );

    //Customer first name
    $tld_wcdpue_customer_fname = get_post_meta( $tld_wcdpue_result->order_id, "_billing_first_name", true );

    //Customer last name
    $tld_wcdpue_customer_lname = get_post_meta( $tld_wcdpue_result->order_id, "_billing_last_name", true );

    //Customer full name

    $tld_wcdpue_customer_full_name = $tld_wcdpue_customer_fname . ' ' . $tld_wcdpue_customer_lname;

    $tld_wcdpue_product_download_url = $tld_wcdpue_result->downloads_markup;

    $tld_wcdpue_download_names = $tld_wcdpue_result->download_names;

    $tld_wcdpue_email_variables = array( "{account_url}", "{account_url_trim}", "{product_name}", "{product_url}", "{product_url_trim}", "{first_name}", "{last_name}", "{full_name}", "{download_url}", "{product_img}", "{download_name}" );

    $tld_wcdpue_email_variables_replace = array( $tld_wcdpue_account_url, $tld_wcdpue_account_url_trim, $tld_wcdpue_product_name, $tld_wcdpue_product_url, $tld_wcdpue_product_url_trim, $tld_wcdpue_customer_fname, $tld_wcdpue_customer_lname, $tld_wcdpue_customer_full_name, $tld_wcdpue_product_download_url, $tld_wcdpue_product_img, $tld_wcdpue_download_names );

    $tld_wcdpue_email_address = $tld_wcdpue_result->user_email;

    $tld_wcdpue_email_subject = str_replace( $tld_wcdpue_email_variables, $tld_wcdpue_email_variables_replace, $tld_wcdpue_email_subject );

    $tld_wcdpue_email_body = str_replace( $tld_wcdpue_email_variables, $tld_wcdpue_email_variables_replace, $tld_wcdpue_email_body );

    // NOTE Below is code for {product_id} magic tag, formatting is still buggy so not made public knowledge yet

    // //we need to first extract the full magic tag
    // preg_match( '/{product_id=([^a-z_{}=][0-9]{0,9}.+)}/', $tld_wcdpue_email_body, $tld_wcdpue_magic_tag  );
    //
    // $tld_wcdpue_magic_tag = $tld_wcdpue_magic_tag[0];
    //
    // //then we clean it up a bit to get IDs
    // preg_match( '/([^a-z_{}=][0-9]{0,9}.+[^}])/', $tld_wcdpue_magic_tag , $tld_wcdpue_magic_product_ids  );
    //
    // $tld_wcdpue_magic_product_ids = $tld_wcdpue_magic_product_ids[0];
    //
    // //then we split it to get single IDs
    // $tld_wcdpue_extract_magic_ids = explode( ',', $tld_wcdpue_magic_product_ids );
    //
    // $tld_wcdpue_magic_product_img = '';
    //
    // //TODO: Try creating another version of the magic tag which would not output the table CSS but instead let a user be able to center using the editor. The code below already has a good version, just try to create an alternative maybe using list items like before.
    //
    // $count = 0;
    // foreach ( $tld_wcdpue_extract_magic_ids as $key => $id ) {
    //   //get the woocommerce product
    //   $tld_wcdpue_extract_magic_product = wc_get_product( $id );
    //   $count = $count+1;
    //   // $tld_wcdpue_magic_product_img .= '<a href="'. get_permalink( $id ) .'">'. wp_get_attachment_image( get_post_thumbnail_id( $id ), "thumbnail", "", array( "style" => "font-family: Georgia; color: #697c52; font-style: italic; font-size: 20px;" ) ) . $tld_wcdpue_extract_magic_product->get_title() .$tld_wcdpue_extract_magic_product->get_price_html().'</a>';
    //
    //   //format 1
    //
    //
    //   $tld_wcdpue_magic_product_img .= '<td align="center" style="min-height: 300px !important;">'. wp_get_attachment_image( get_post_thumbnail_id( $id ), "thumbnail", "", array( "style" => "font-family: Georgia; color: #697c52; font-style: italic; font-size: 20px;" ) ) .'<br><a href="'. get_permalink( $id ) .'">'. $tld_wcdpue_extract_magic_product->get_title() .'<br>'.$tld_wcdpue_extract_magic_product->get_price_html().'</a></td>';
    //
    //   if ( $count % 4 == 0 ){
    //
    //     $tld_wcdpue_magic_product_img = '<tr>'.$tld_wcdpue_magic_product_img.'</tr>';
    //
    //   }
    //
    //   // format 2
    //
    //   // $tld_wcdpue_magic_product_img .= '<li style="text-align:center;float:left;margin:0 auto;list-style-type:none;width:32%;min-height:230px;word-wrap:break-word;">'. wp_get_attachment_image( get_post_thumbnail_id( $id ), "thumbnail", "", array( "style" => "font-family: Georgia; color: #697c52; font-style: italic; font-size: 20px;" ) ) . '<br>' . $tld_wcdpue_extract_magic_product->get_title() . '<br>' .$tld_wcdpue_extract_magic_product->get_price_html().'</li>';
    //
    // }
    //
    // $tld_wcdpue_email_format = esc_attr( get_option( 'tld_wcdpue_wc_default_styles' ) );
    //
    // //Add spacing between product images based on email format
    // if( !empty( $tld_wcdpue_email_format ) ){
    //
    //   // $tld_wcdpue_magic_product_img;
    //   $tld_wcdpue_magic_product_img = '<table width="100%" border="0" cellspacing="0" cellpadding="0"><tbody>'. $tld_wcdpue_magic_product_img . '</tbody></table>';
    //   // $tld_wcdpue_magic_product_img = '<table width="100%" border="0" cellspacing="0" cellpadding="0"><tbody><tr>'. $tld_wcdpue_magic_product_img . '</tr></tbody></table>';
    //
    // }else{
    //
    //   $tld_wcdpue_magic_product_img;
    //   // $tld_wcdpue_magic_product_img = '<div id="tes">' . $tld_wcdpue_magic_product_img . '</div>';
    //
    // }
    //
    // // NOTE uncomment this when {product_id} magic tag feature is implimented
    //
    // $tld_wcdpue_email_body = str_replace( $tld_wcdpue_magic_tag, $tld_wcdpue_magic_product_img, $tld_wcdpue_email_body );


    add_filter( 'wp_mail_content_type', 'tld_wcdpue_html_mail' );

    //send email
    //TODO: Check why without email first name column field being off
    //NOTE: Debugging
    // do_action( 'tld_wcdpue_send_email', '', $tld_wcdpue_email_subject, $tld_wcdpue_email_body, $tld_wcdpue_customer_fname, $tld_wcdpue_customer_lname );
    do_action( 'tld_wcdpue_send_email', $tld_wcdpue_email_address, $tld_wcdpue_email_subject, $tld_wcdpue_email_body, $tld_wcdpue_customer_full_name, $tld_wcdpue_product_name );

    remove_filter( 'wp_mail_content_type', 'tld_wcdpue_html_mail' );

    //delete the current row in loop after mail sent, also delete any duplicate row
    $wpdb->delete(
      $tld_wcdpue_the_scheduling_table,
      array(
        'product_id'           => $tld_wcdpue_result->product_id,
        'product_parent'       => $tld_wcdpue_result->product_parent,
        'order_id'             => $tld_wcdpue_result->order_id,
        'order_key'            => $tld_wcdpue_result->order_key,
        'user_email'           => $tld_wcdpue_result->user_email
      ) );

      sleep(5); //short breath, no rush.

    }

  }
  ?>
