<?php

defined( 'ABSPATH' ) or die( 'But why!?' );

function tld_wcdpue_setup_table(){

  if ( ! current_user_can( 'activate_plugins' ) ) {

    return;

  }

  // https://wordpress.stackexchange.com/questions/218194/can-i-create-two-tables-at-single-time-while-installation-of-custom-plugin

  global $wpdb;
  $tld_wcdpue_scheduled_tbl = TLD_WCDPUE_SCHEDULED_TABLE;
  $tld_wcdpue_log_tbl = TLD_WCDPUE_LOG_TABLE;

  //set table version
  $tld_wcdpue_tbl_version   = '1.4.1';

  if ( empty( get_option( 'tld_wcdpue_tbl_version' ) ) || get_option( 'tld_wcdpue_tbl_version' ) != '1.4.1'  ){

    global $wpdb;
    require_once ( ABSPATH . 'wp-admin/includes/upgrade.php');
    $tld_wcdpue_scheduled_tbl = TLD_WCDPUE_SCHEDULED_TABLE;
    $tld_wcdpue_log_tbl = TLD_WCDPUE_LOG_TABLE;
    $charset_collate = $wpdb->get_charset_collate();

    // create log table
    $log = "CREATE TABLE $tld_wcdpue_log_tbl (
      id bigint(20) NOT NULL AUTO_INCREMENT,
      customer varchar(100),
      email varchar(50) NOT NULL,
      product_name varchar(500),
      status varchar(17) NOT NULL,
      time_stamp varchar(200) NOT NULL,
      PRIMARY KEY id  (id)
    ) $charset_collate;";
    dbDelta ( $log );

    $sql = "CREATE TABLE $tld_wcdpue_scheduled_tbl (
      id bigint(20) NOT NULL AUTO_INCREMENT,
      product_id bigint(20),
      product_parent bigint(20) DEFAULT '0',
      order_id bigint(20),
      order_key varchar(200),
      user_email varchar(200) DEFAULT '',
      is_variable tinyint(1) DEFAULT '0',
      downloads_markup longtext,
      download_names longtext,
      PRIMARY KEY id  (id)
    ) $charset_collate;";
    dbDelta ( $sql );
  }

  //set log format
  update_option ( 'tld_wcdpue_log_date_format', 'd-m-Y H:i:s' );
  //set table version
  update_option ( 'tld_wcdpue_tbl_version', $tld_wcdpue_tbl_version );

}
?>
