<?php
/*
Plugin Name: WCDPUE Pro | Shared By Themes24x7.com
Plugin URI: https://codecanyon.net/item/woocommerce-downloadable-product-update-emails/18908283
Description: Inform customers when there is an update to their Woocommerce downloadable product via email.
Version: 1.4.1
Author: پرشین اسکریپت
Author URI: http://www.persianscript.ir
WC requires at least: 2.6.0
WC tested up to: 3.5.0
License: GPL2
*/

global $wpdb;

defined( 'ABSPATH' ) or die( 'But why!?' );

define ( 'TLD_WCDPUE_DB_PREFIX', $wpdb->prefix );

define ( 'TLD_WCDPUE_DB_POSTS_TABLE', TLD_WCDPUE_DB_PREFIX . 'posts' );

define ( 'TLD_WCDPUE_DLS_TABLE', TLD_WCDPUE_DB_PREFIX . 'woocommerce_downloadable_product_permissions' );

define ( 'TLD_WCDPUE_SCHEDULED_TABLE', TLD_WCDPUE_DB_PREFIX . 'wcdpue_scheduled' );

define ( 'TLD_WCDPUE_LOG_TABLE', TLD_WCDPUE_DB_PREFIX . 'wcdpue_log' );

define ( 'TLD_WCDPUE_DEBUG', false );

//table setup
require_once dirname( __FILE__ ) . '/includes/tld-table-setup.php';

//schedule setup
include dirname( __FILE__ ) . '/includes/tld-schedule-mail.php';

//welcome screen
include dirname( __FILE__ ) . '/includes/admin/tld-welcome-screen.php';

//options page setup
include dirname( __FILE__ ) . '/includes/admin/tld-settings-page.php';

//admin review notice
include dirname( __FILE__ ) . '/includes/admin/tld-notice.php';

//log
include dirname( __FILE__ ) . '/includes/admin/tld-log.php';

//activation/deactivation tasks

register_activation_hook( __FILE__, 'tld_wcdpue_setup_table' );
register_activation_hook( __FILE__, 'tld_wcdpue_activate_schedule' );
register_activation_hook( __FILE__, 'tld_wcdpue_welcome_screen_activate' );
register_deactivation_hook( __FILE__, 'tld_wcdpue_deactivate_schedule');

//register our assets
function tld_wcdpue_load_assets() {

	global $wp_scripts;


	// get registered script object for jquery-ui and tell WordPress to load the Smoothness theme from Google CDN
	$tld_wcdpue_jquery_ui = $wp_scripts->query('jquery-ui-core');
	// do_action('tld_wcdpue_log_now', $tld_wcdpue_jquery_ui);

	$tld_wcdpue_jquery_ui_protocol = is_ssl() ? 'https' : 'http';
	$tld_wcdpue_jquery_ui_url = "$tld_wcdpue_jquery_ui_protocol://ajax.googleapis.com/ajax/libs/jqueryui/{$tld_wcdpue_jquery_ui->ver}/themes/smoothness/jquery-ui.min.css";
	wp_enqueue_style('jquery-ui-smoothness', $tld_wcdpue_jquery_ui_url, false, null);
	wp_enqueue_script( 'jquery-ui-accordion' );
	// wp_enqueue_style( 'wp-jquery-ui-dialog' );
	wp_enqueue_script( 'jquery-effects-fade' );
	wp_enqueue_script( 'jquery-ui-tabs' );




	wp_enqueue_script( 'tld_wcdpue_uilang', plugin_dir_url( __FILE__ ) . 'assets/js/uilang.js' );
	wp_enqueue_script( 'tld_wcdpue_cookiejs', plugin_dir_url( __FILE__ ) . 'assets/js/js.cookie.js?v1.0.0' );
	wp_enqueue_script( 'tld_wcdpue_scripts', plugin_dir_url( __FILE__ ) . 'assets/js/tld-scripts.js?v1.4.2');
	// wp_enqueue_script( 'tld_wcdpue_scripts', plugin_dir_url( __FILE__ ) . 'assets/js/tld-scripts.js?'. time(), array( 'jquery' ), true );
	wp_enqueue_script( 'tld_wcdpue_clipboard', plugin_dir_url( __FILE__ ) . 'assets/js/clipboard.min.js' );
	wp_enqueue_script( 'tld_wcdpue_SelectWooJS', plugin_dir_url( __FILE__ ) . 'assets/js/selectWoo.min.js' );
	wp_enqueue_style( 'tld_wcdpue_styles', plugin_dir_url( __FILE__ ) . 'assets/css/style.css?v1.4.2' );
	wp_enqueue_style( 'tld_wcdpue_SelectWooCSS', plugin_dir_url( __FILE__ ) . 'assets/css/selectWoo.min.css' );
	wp_enqueue_script( 'jquery-ui-dialog' );

}
add_action( 'admin_enqueue_scripts', 'tld_wcdpue_load_assets' );
// add_action( 'admin_init', 'tld_wcdpue_load_assets' );


// NOTE Simple debug function for testing different parts of plugin execution

function tld_wcdpue_create_log( $log ){
	$file =  dirname(__File__) . '/log.txt';
	// Open the file to get existing content
	$current = file_get_contents( $file );
	// Append a new log to the file
	$current .= $log . "\n\n";
	// Write the contents back to the file
	file_put_contents($file, $current);
}
add_action( 'tld_wcdpue_log_now', 'tld_wcdpue_create_log' );


if ( function_exists( 'tld_wcdpue_review_notice' ) ) {

	register_activation_hook( __FILE__,  'tld_wcdpue_set_review_trigger_date' );

	/**
	* Set Trigger Date.
	*
	* @since  1.0.0
	*/
	function tld_wcdpue_set_review_trigger_date() {

		// Number of days you want the notice delayed by.
		$tld_wcdpue_delayindays = 30;

		// Create timestamp for when plugin was activated.
		$tld_wcdpue_triggerdate = mktime( 0, 0, 0, date('m')  , date('d') + $tld_wcdpue_delayindays, date('Y') );

		// If our option doesn't exist already, we'll create it with today's timestamp.
		if ( ! get_option( 'tld_wcdpue_activation_date') ) {
			add_option( 'tld_wcdpue_activation_date', $tld_wcdpue_triggerdate, '', 'yes' );
		}

	}

}

// check if WooCommerce is activated
function tld_wcdpue_wc_check(){

	if ( class_exists( 'woocommerce' ) ) {

		global $tld_wcdpue_wc_active;
		$tld_wcdpue_wc_active = 'yes';

	} else {

		global  $tld_wcdpue_wc_active;
		$tld_wcdpue_wc_active = 'no';

	}

}
add_action( 'admin_init', 'tld_wcdpue_wc_check' );

// show admin notice if WooCommerce is not activated
function tld_wcdpue_wc_active(){

	global  $tld_wcdpue_wc_active;

	if ( $tld_wcdpue_wc_active == 'no' ){
		?>

		<div class="notice notice-error is-dismissible">
			<p>WooCommerce is not activated, please activate it to use <b>WCDPUE Pro.</b></p>
		</div>
		<?php

	}

}
add_action('admin_notices', 'tld_wcdpue_wc_active');

//deactivate schedule cron job
function tld_wcdpue_deactivate_schedule() {

	if ( ! current_user_can( 'activate_plugins' ) ) {
		return;
	}

	$plugin = isset( $_REQUEST['plugin'] ) ? $_REQUEST['plugin'] : '';

	check_admin_referer( "deactivate-plugin_{$plugin}" );

	wp_clear_scheduled_hook( 'tld_wcdpue_email_burst' );

}

//Quick cron job for user convenience
function tld_wcdpue_cron_quarter_hour( $schedules ){

	$schedules['tld_quick_cron'] = array(

		'interval' => 900,
		'display' => __( 'Every 15 Minutes' )

	);

	return $schedules;

}
add_filter( 'cron_schedules', 'tld_wcdpue_cron_quarter_hour' );

function tld_wcdpue_create_action_links ( $tld_wcdpue_plugin_action_links ) {

	$tld_wcdpue_action_link = array(
		'<a href="' . admin_url( 'options-general.php?page=wcdpue-pro' ) . '">Settings</a>',
	);
	return array_merge( $tld_wcdpue_action_link, $tld_wcdpue_plugin_action_links );

}
add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'tld_wcdpue_create_action_links' );

// delete this code later down the line once confident all users have updated
// Note passive db check
function tld_wcdpue_dbupdated_check(){

	if ( get_option( 'tld_wcdpue_tbl_version' ) != "1.4.1" ){


		global $wpdb;
		require_once ( ABSPATH . 'wp-admin/includes/upgrade.php');
		$tld_wcdpue_scheduled_tbl = TLD_WCDPUE_SCHEDULED_TABLE;
		$tld_wcdpue_log_tbl = TLD_WCDPUE_LOG_TABLE;
		$charset_collate = $wpdb->get_charset_collate();

		// create log table
		$log = "CREATE TABLE $tld_wcdpue_log_tbl (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			customer varchar(100),
			email varchar(50) NOT NULL,
			product_name varchar(500),
			status varchar(17) NOT NULL,
			time_stamp varchar(200) NOT NULL,
			PRIMARY KEY id  (id)
		) $charset_collate;";
		dbDelta ( $log );

		$sql = "CREATE TABLE $tld_wcdpue_scheduled_tbl (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			product_id bigint(20),
			product_parent bigint(20) DEFAULT '0',
			order_id bigint(20),
			order_key varchar(200),
			user_email varchar(200) DEFAULT '',
			is_variable tinyint(1) DEFAULT '0',
			downloads_markup longtext,
			download_names longtext,
			PRIMARY KEY id  (id)
		) $charset_collate;";
		dbDelta ( $sql );

		// $wpdb->query(
		//
		// 	"ALTER TABLE $tld_wcdpue_scheduled_tbl
		// 	ADD download_id VARCHAR(32)
		// 	AFTER id,
		// 	ADD order_key VARCHAR(200)
		// 	AFTER order_id;"
		//
		// );

		// set notice trigger date manually
		// Number of days you want the notice delayed by.
		$tld_wcdpue_delayindays = 30;

		// Create timestamp for when plugin was activated.
		$tld_wcdpue_triggerdate = mktime( 0, 0, 0, date('m')  , date('d') + $tld_wcdpue_delayindays, date('Y') );

		// If our option doesn't exist already, we'll create it with today's timestamp.
		if ( ! get_option( 'tld_wcdpue_activation_date') ) {
			add_option( 'tld_wcdpue_activation_date', $tld_wcdpue_triggerdate, '', 'yes' );
		}

		//set log format
		update_option ( 'tld_wcdpue_log_date_format', 'd-m-Y H:i:s' );
		//set table version
		update_option ( 'tld_wcdpue_tbl_version', '1.4.1' );

	}

}
add_action( 'admin_init', 'tld_wcdpue_dbupdated_check' );

// +++++ Actions and Filters +++++
function tld_wcdpue_do_email_business( $tld_wcdpue_email_address, $tld_wcdpue_email_subject, $tld_wcdpue_email_body, $tld_wcdpue_customer_full_name, $tld_wcdpue_product_name ){

	global $wpdb;
	global $woocommerce;
	$tld_wcdpue_the_log_table = TLD_WCDPUE_LOG_TABLE;
	$tld_wcdpue_log_date_format = get_option( 'tld_wcdpue_log_date_format' );
	//format blog current time to format user chose
	$tld_wcdpue_current_blog_time = current_time( $tld_wcdpue_log_date_format );

	//check whether to use default WC styles or bundled templates
	$tld_wcdpue_email_format = esc_attr( get_option( 'tld_wcdpue_wc_default_styles' ) );

	if ( !empty( $tld_wcdpue_email_format ) ){
		//Wrap email around WC default styles
		$tld_wcdpue_wc_mailer = $woocommerce->mailer();
		$tld_wcdpue_email_body = $tld_wcdpue_wc_mailer->wrap_message( $tld_wcdpue_email_subject, $tld_wcdpue_email_body );

		global $tld_wcdpue_emails_sent_count;

		if ( $tld_wcdpue_wc_mailer->send( $tld_wcdpue_email_address, $tld_wcdpue_email_subject, $tld_wcdpue_email_body ) ){

			// log send status
			$wpdb->insert(
				$tld_wcdpue_the_log_table,
				array(

					'customer' 				=> $tld_wcdpue_customer_full_name,
					'email' 					=> $tld_wcdpue_email_address,
					'product_name' 		=> $tld_wcdpue_product_name,
					'status'					=> 'Sending Completed',
					'time_stamp' 			=> $tld_wcdpue_current_blog_time

				)
			);
			$tld_wcdpue_emails_sent_count++;
			// NOTE logging
			// do_action( 'tld_wcdpue_log_now', $tld_wcdpue_emails_sent_count );

		}else{

			$wpdb->insert(
				$tld_wcdpue_the_log_table,
				array(

					'customer' 				=> $tld_wcdpue_customer_full_name,
					'email' 					=> $tld_wcdpue_email_address,
					'product_name' 		=> $tld_wcdpue_product_name,
					'status'					=> 'Sending Failed',
					'time_stamp' 			=> $tld_wcdpue_current_blog_time

				)
			);

		};

	}else{

		global $tld_wcdpue_emails_sent_count;

		if ( wp_mail( $tld_wcdpue_email_address, $tld_wcdpue_email_subject, $tld_wcdpue_email_body ) ) {

			$wpdb->insert(
				$tld_wcdpue_the_log_table,
				array(

					'customer' 				=> $tld_wcdpue_customer_full_name,
					'email' 					=> $tld_wcdpue_email_address,
					'product_name' 		=> $tld_wcdpue_product_name,
					'status'					=> 'Sending Completed',
					'time_stamp' 			=> $tld_wcdpue_current_blog_time

				)
			);
			$tld_wcdpue_emails_sent_count++;

		}else{

			$wpdb->insert(
				$tld_wcdpue_the_log_table,
				array(

					'customer' 				=> $tld_wcdpue_customer_full_name,
					'email' 					=> $tld_wcdpue_email_address,
					'product_name' 		=> $tld_wcdpue_product_name,
					'status'					=> 'Sending Failed',
					'time_stamp' 			=> $tld_wcdpue_current_blog_time

				)
			);

		};

	}

}

add_action('tld_wcdpue_send_email', 'tld_wcdpue_do_email_business', '', 5 );

function tld_wcdpue_get_buyer_count( $tld_wcdpue_product_id ){

	global $wpdb;
	$tld_wcdpue_dls_table = TLD_WCDPUE_DLS_TABLE;

	$tld_wcdpue_query_result = $wpdb->get_var(

		"SELECT COUNT( DISTINCT product_id, order_id, order_key, user_email )
		FROM $tld_wcdpue_dls_table
		WHERE ( product_id = $tld_wcdpue_product_id )
		AND ( access_expires > NOW() OR access_expires IS NULL )
		");

		echo $tld_wcdpue_query_result;

	}
	//create action for counting buyers
	add_action( 'tld_wcdpue_calc_buyers', 'tld_wcdpue_get_buyer_count', '', 1 );

	function tld_wcdpue_trim_url( $tld_wcdpue_trimmed_url ){

		// check if ssl used on server
		if ( ( !empty( $_SERVER['HTTPS'] ) && $_SERVER['HTTPS'] !== 'off' ) || $_SERVER['SERVER_PORT'] == 443 ){

			$tld_wcdpue_trimmed_url = ltrim( $tld_wcdpue_trimmed_url, "https://" );
			return $tld_wcdpue_trimmed_url;

			//check if ssl used on load balancers such as cloudflare
		}elseif ( !empty( $_SERVER['HTTP_X_FORWARDED_PROTO'] ) && $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https' ) {

			$tld_wcdpue_trimmed_url = ltrim( $tld_wcdpue_trimmed_url, "https://" );
			return $tld_wcdpue_trimmed_url;

		}else{

			$tld_wcdpue_trimmed_url = ltrim( $tld_wcdpue_trimmed_url, "http://" );
			return $tld_wcdpue_trimmed_url;

		}

	}

	add_filter( 'tld_wcdpue_url_trim', 'tld_wcdpue_trim_url', '', 1 );

	//register our metabox if this is a downloadable product
	function tld_wcdpue_metabox(){

		global $pagenow;

		$tld_wcdpue_product = wc_get_product( get_the_ID() );

		if( $tld_wcdpue_product->is_type( 'variable' ) ){

			$ids = $tld_wcdpue_product->get_children();

			foreach( $ids as $id ){

				$tld_wcdpue_variable_product = wc_get_product( $id );

				if( $tld_wcdpue_variable_product->is_downloadable() ){
					$variable_download = true;
					break;
				}

			}

		}

		if ( $pagenow != 'post-new.php' && ( $tld_wcdpue_product->is_downloadable() || $variable_download == true ) ){
			add_meta_box(
				'tld_wcdpue_metabox',
				'Email Options',
				'tld_metabox_fields',
				'',
				'side',
				'high'
			);

		}

	}
	add_action( 'add_meta_boxes_product', 'tld_wcdpue_metabox', 10, 2 );

	//query number of customers who have bought this product
	function tld_get_product_owners(){

		global $wpdb;

		$tld_wcdpue_product_id = get_the_ID();
		$tld_wcdpue_product = wc_get_product( get_the_ID() );
		$tld_wcdpue_dls_table = TLD_WCDPUE_DLS_TABLE;
		$tld_wcdpue_posts_table = TLD_WCDPUE_DB_POSTS_TABLE;

		if( $tld_wcdpue_product->is_type( 'variable' ) ){
			$tld_wcdpue_buyer_count = 0;
			$tld_wcdpue_variable_product_IDs = $wpdb->get_results(
				"SELECT ID
				FROM $tld_wcdpue_posts_table
				WHERE ( post_parent = $tld_wcdpue_product_id )
				AND ( post_type != 'revision' )
				"
			);

			foreach ( $tld_wcdpue_variable_product_IDs as $tld_wcdpue_variable_product_ID ){

				$tld_wcdpue_variable_permission_IDs = $wpdb->get_results(
					"SELECT DISTINCT product_id, order_id, order_key, user_email
					FROM $tld_wcdpue_dls_table
					WHERE ( product_id = $tld_wcdpue_variable_product_ID->ID )
					AND (access_expires > NOW() OR access_expires IS NULL )
					"	);

					foreach ( $tld_wcdpue_variable_permission_IDs as $tld_wcdpue_variable_permission_ID ) {

						$tld_wcdpue_buyer_count++;

					}

				}

				echo $tld_wcdpue_buyer_count;

			}else{

				do_action('tld_wcdpue_calc_buyers', $tld_wcdpue_product_id );

			}

		}

		//add our metabox fields
		function tld_metabox_fields(){

			global $wpdb;
			$tld_wcdpue_product_id = get_the_ID();
			$tld_wcdpue_product = wc_get_product( $tld_wcdpue_product_id );
			$tld_wcdpue_posts_table = TLD_WCDPUE_DB_POSTS_TABLE;
			$tld_wcdpue_using_downloads_magictag = get_option( 'tld_wcdpue_using_downloads_magictag' );
			// NOTE This is better than database query for variable products
			$tld_wcdpue_children_ids = $tld_wcdpue_product->get_children();

			?>

			<div class="tld-wcdpue-center-text">

				<div>
					<p>Unique download access count: <?php tld_get_product_owners(); ?></p>
				</div>

				<div id="tld-wcdpue-variation-checkboxes-wrap">

					<?php

					if( $tld_wcdpue_product->is_type( 'variable' ) ){

						foreach ( $tld_wcdpue_children_ids as $tld_wcdpue_child_id ){

							$tld_wcdpue_variable_product = wc_get_product( $tld_wcdpue_child_id );

							if( $tld_wcdpue_variable_product->is_downloadable() ){

								echo '<small>'. get_the_title( $tld_wcdpue_child_id ) .' has <span style="color: green; font-weight: bold;">';
								do_action('tld_wcdpue_calc_buyers', $tld_wcdpue_child_id );
								echo "</span> buyers <br/></small>";

							}

						}

					}
					?>

				</div>

				<?php

				if ( ! $tld_wcdpue_product->is_type( 'variable' ) ){

					if( $tld_wcdpue_using_downloads_magictag == "on" ){

						echo '<div><select class="tld-wcdpue-product-name-select" name="tld_wcdpue_download_ids[]" multiple="multiple">';

						//get array of download details for this product
						$tld_wcdpue_product_downloads = $tld_wcdpue_product->get_downloads();
						//loop through array and get ID and name
						foreach( $tld_wcdpue_product_downloads as $key => $download ) {
							echo '<option value="' . $download["id"] . '">' . $download["name"] . '</option>';
						}

						echo '</select></div>';
					}

				}else{

					echo '<div><select class="tld-wcdpue-product-name-select" name="tld_wcdpue_download_ids[]" multiple="multiple">';

					foreach ( $tld_wcdpue_children_ids as $tld_wcdpue_child_id ){

						// get the product object based on the ids
						$tld_wcdpue_variable_product_object = wc_get_product ( $tld_wcdpue_child_id );

						// check if this is a downloadable variation
						if ( $tld_wcdpue_variable_product_object->is_downloadable() ){
							$tld_wcdpue_product_variation_downloads = $tld_wcdpue_variable_product_object->get_downloads();
							//loop and get download name and id
							foreach( $tld_wcdpue_product_variation_downloads as $object => $data ){

								echo '<option value="' . $data['id'] . '">' . $data['name'] .'</option>';

							}
						}



					}

					echo '</select></div>';

				}

				?>
				<div id='tld-switch' onclick="tld_cookie_business()">
					<div id='circle'></div>
				</div>

				<div>
					<label for="tld-option-selected" id="meta-switch-label">Deactivated</label>
				</div>

				<div class="tld-wcdpue-top-margin">

					<?php if ( ! $tld_wcdpue_product->is_type( 'variable' ) && get_option( 'tld_wcdpue_show_immediately' ) == "on"  ){ ?>
						<input type="radio" name="tld-option-selected" value="schedule" checked><span>Schedule</span>
						<input type="radio" name="tld-option-selected" value="immediately"><span style="margin-right: 10px;">Immediately</span>
					<?php }else{ ?>
						<input style="display: none;" type="radio" name="tld-option-selected" value="schedule" checked>
					<?php } ?>
				</div>

				<div id="tld-wcdpue-email-status"></div>

				<!-- start switch magic -->

				<code style="display: none;">
					clicking on "#tld-switch" toggles class "active" on "#tld-switch"
				</code>

				<!-- end switch magic -->

			</div>

			<?php
		}

		//allow HTML emails
		function tld_wcdpue_html_mail() {
			return 'text/html';
		}

		//perform our tasks on post save
		function tld_wcdpue_post_saved( $post_id ) {

			if( isset( $_COOKIE['tld-wcdpue-cookie'] ) ) {

				if ( wp_is_post_revision( $post_id ) || wp_is_post_autosave( $post_id ) )
				return;

				$tld_wcdpue_no_spam = array();
				global $wpdb;

				$tld_wcdpue_dls_table = TLD_WCDPUE_DLS_TABLE;

				$tld_wcdpue_the_schedule_table = TLD_WCDPUE_SCHEDULED_TABLE;
				// get selected download names from metabox
				$tld_wcdpue_updated_downloads_ids = $_POST['tld_wcdpue_download_ids'];
				// get option for whether using magic tag
				$tld_wcdpue_using_downloads_magictag = get_option( 'tld_wcdpue_using_downloads_magictag' );

				//get our options
				$tld_wcdpue_account_url = esc_url ( get_permalink( get_option( 'woocommerce_myaccount_page_id' ) ) );

				$tld_wcdpue_account_url_trim = apply_filters( 'tld_wcdpue_url_trim', $tld_wcdpue_account_url );

				$tld_wcdpue_product = wc_get_product( get_the_ID() );

				//Do work if product is variable product
				if( $tld_wcdpue_product->is_type( 'variable' ) ){


					if( isset( $tld_wcdpue_updated_downloads_ids ) ) {

						foreach( $tld_wcdpue_updated_downloads_ids as $tld_wcdpue_updated_downloads_id ) {
							$tld_wcdpue_query_result = '';
							//where variable is in quotes because without it doesn't work in this case
							$tld_wcdpue_query_result = $wpdb->get_results(
								"SELECT DISTINCT download_id, product_id, order_id, order_key, user_email
								FROM $tld_wcdpue_dls_table
								WHERE ( download_id = '$tld_wcdpue_updated_downloads_id' )
								AND ( access_expires > NOW() OR access_expires IS NULL )
								"	);
								foreach ( $tld_wcdpue_query_result as $tld_wcdpue_result ){


									$tld_wcdpue_email_address = $tld_wcdpue_result->user_email;

									//get user id via email
									$tld_wcdpue_customer_details = get_user_by( 'email', $tld_wcdpue_email_address );
									// TODO add check for if magic tag being used to not run this code.
									if( ! empty( $tld_wcdpue_customer_details->ID ) && $tld_wcdpue_customer_details->ID !== 0 ){

										// empty download markup variable
										$tld_wcdpue_downloads_markup = '';

										// empty download names variable
										$tld_wcdpue_download_names = '';

										//get current user in loop available downloads
										$tld_wcdpue_customer_downloads = wc_get_customer_available_downloads( $tld_wcdpue_customer_details->ID );

										foreach( $tld_wcdpue_updated_downloads_ids as $tld_wcdpue_updated_downloads_id ) {

											foreach ( $tld_wcdpue_customer_downloads as $download => $data ){
												//get the download link only for product names which were selected
												if ( $data["download_id"] == $tld_wcdpue_updated_downloads_id ){
													$tld_wcdpue_downloads_markup .= '<br/><br/><a href="' . $data['download_url'] . '">' . $data['download_name'] . '</a>' ;
													$tld_wcdpue_download_names .= ' ' . $data["download_name"] . ' ';
												}

											}

										}

									}else{

										//
										//NOTE without below registered users would not have info in their downloads_markup and download_names column
										//empty the download link variable
										$tld_wcdpue_downloads_markup = '';

										// empty download names variable
										$tld_wcdpue_download_names = '';
										//this is for guest download links
										$tld_wcdpue_guest_downloads = $wpdb->get_results(
											"SELECT DISTINCT download_id, product_id, order_id, order_key, user_email
											FROM $tld_wcdpue_dls_table
											WHERE ( user_email = '$tld_wcdpue_email_address' )
											AND ( access_expires > NOW() OR access_expires IS NULL )
											"	);

											foreach( $tld_wcdpue_updated_downloads_ids as $tld_wcdpue_updated_downloads_id ) {

												foreach( $tld_wcdpue_guest_downloads as $tld_wcdpue_guest_download ){

													$tld_wcdpue_product = wc_get_product(  $tld_wcdpue_guest_download->product_id );

													$tld_wcdpue_product_downloads = $tld_wcdpue_product->get_downloads();

													if ( $tld_wcdpue_guest_download->download_id == $tld_wcdpue_updated_downloads_id && $tld_wcdpue_email_address == $tld_wcdpue_guest_download->user_email ){
														$tld_wcdpue_downloads_markup .= '<br/><br/><a href="'. site_url( '/?download_file=' . $tld_wcdpue_guest_download->product_id . '&order=' . $tld_wcdpue_guest_download->order_key . '&email='. $tld_wcdpue_email_address . '&key=' . $tld_wcdpue_guest_download->download_id ) .'">'. $tld_wcdpue_product_downloads[$tld_wcdpue_guest_download->download_id]['name'] .'</a><br/><br/>';
														$tld_wcdpue_download_names .= ' ' . $tld_wcdpue_product_downloads[$tld_wcdpue_guest_download->download_id]['name'];
													}

												}

											}

										}

										if( ! in_array( $tld_wcdpue_email_address, $tld_wcdpue_no_spam ) ){

											$wpdb->insert(
												$tld_wcdpue_the_schedule_table,
												array(

													'product_id' 					=> $tld_wcdpue_result->product_id,
													'product_parent'			=> $post_id,
													'order_id' 						=> $tld_wcdpue_result->order_id,
													'order_key'						=> $tld_wcdpue_result->order_key,
													'user_email' 					=> $tld_wcdpue_result->user_email,
													'is_variable' 				=> 1,
													'downloads_markup' 		=> $tld_wcdpue_downloads_markup,
													'download_names' 			=> $tld_wcdpue_download_names,

												)
											);

											$tld_wcdpue_emails_scheduled++;

										}

										$tld_wcdpue_no_spam[] = $tld_wcdpue_result->user_email;

									}

									setcookie( "tld-wcdpue-emails-scheduled", $tld_wcdpue_emails_scheduled );

								}
							}

						}



						//NOTE if is not variable product do work
						if( ! $tld_wcdpue_product->is_type( 'variable' ) ){

							$tld_wcdpue_sending_option_selected = $_POST['tld-option-selected'];

							//counts the unique rows without the download ID
							$tld_wcdpue_query_result = $wpdb->get_results(
								"SELECT DISTINCT product_id, order_id, order_key, user_email
								FROM $tld_wcdpue_dls_table
								WHERE ( product_id = $post_id )
								AND (access_expires > NOW() OR access_expires IS NULL )
								"
							);
							// TODO Add option for sending email to persons with 0 downloads left.
							// let user also be able to send email to expired downloads
							// TODO Test when downloads permissions reach 0 or expires what happens to link in email
							if ( $tld_wcdpue_sending_option_selected == 'immediately' ){

								//looping through returned download permissions for product
								foreach ( $tld_wcdpue_query_result as $tld_wcdpue_result ){

									$tld_wcdpue_email_address = $tld_wcdpue_result->user_email;

									if( $tld_wcdpue_using_downloads_magictag == "on" ){

										//get user id via email
										$tld_wcdpue_customer_details = get_user_by( 'email', $tld_wcdpue_email_address );

										//empty the download link variable
										$tld_wcdpue_product_download_url = '';
										//empty download name variable
										$tld_wcdpue_download_names = '';

										if( isset( $tld_wcdpue_updated_downloads_ids ) ) {

											//looping through selected updated products
											foreach( $tld_wcdpue_updated_downloads_ids as $tld_wcdpue_updated_downloads_id ){

												//if user is registered
												if( ! empty( $tld_wcdpue_customer_details->ID ) && $tld_wcdpue_customer_details->ID !== 0 ){

													//get current user in loop available downloads
													$tld_wcdpue_customer_downloads = wc_get_customer_available_downloads( $tld_wcdpue_customer_details->ID );

													foreach ( $tld_wcdpue_customer_downloads as $download => $data ){
														//get the download link only for product names which were selected
														if ( $data["download_id"] == $tld_wcdpue_updated_downloads_id ){

															// TODO let users style their download button //

															$tld_wcdpue_product_download_url .= '<br/><br/><a href="' . $data["download_url"] . '">' . $data["download_name"] . '</a>' ;
															//getting product download names to use in email
															$tld_wcdpue_download_names .=  ' ' . $data['download_name'];

														}

													}

												}else{

													$tld_wcdpue_product_downloads = $tld_wcdpue_product->get_downloads();

													// This is for guest download links
													foreach( $tld_wcdpue_product_downloads as $key => $download ) {

														if ( $download["id"] == $tld_wcdpue_updated_downloads_id ){
															// TODO let users style their download button
															$tld_wcdpue_product_download_url .=  '<br/><br/><a href="'. site_url( '/?download_file=' . get_the_ID() . '&order=' . $tld_wcdpue_result->order_key . '&email='. $tld_wcdpue_email_address . '&key=' . $download['id'] ) .'">'. $download['name'] .'</a>';
															$tld_wcdpue_download_names .=  ' ' . $download['name'];

														}

													}

												}

											}

										}

									}


									// If not in array email
									if( ! in_array( $tld_wcdpue_result->user_email, $tld_wcdpue_no_spam ) ){
										//if the magic tag option is on but no downloads were selected return
										if( ! isset( $tld_wcdpue_updated_downloads_ids ) && $tld_wcdpue_using_downloads_magictag == "on"){
											return;
										}
										$tld_wcdpue_email_subject = esc_attr( get_option( 'tld_wcdpue_email_subject' ) );

										if ( empty( $tld_wcdpue_email_subject ) ){
											$tld_wcdpue_email_subject = 'A product you bought has been updated!';
										}

										$tld_wcdpue_email_body = get_option( 'tld_wcdpue_settings_email_content' );

										if ( empty( $tld_wcdpue_email_body ) ){
											$tld_wcdpue_email_body = 'There is a new update for one of your digital products! Log into your account to download it: ' . $tld_wcdpue_account_url;
										}

										//product name
										$tld_wcdpue_product_name = get_the_title( $post_id );

										//product image
										$tld_wcdpue_product_img = wp_get_attachment_image( get_post_thumbnail_id( $tld_wcdpue_result->product_id ), "thumbnail", "", array( "style" => "font-family: Georgia; color: #697c52; font-style: italic; font-size: 20px;" ) );

										//product url
										$tld_wcdpue_product_url = get_permalink( $post_id );

										$tld_wcdpue_product_url_trim = apply_filters( 'tld_wcdpue_url_trim', $tld_wcdpue_product_url );
										// TODO use customer_details variable to get first and last name
										//customer first name
										$tld_wcdpue_customer_fname = get_post_meta( $tld_wcdpue_result->order_id, "_billing_first_name", true );

										//customer last name
										$tld_wcdpue_customer_lname = get_post_meta( $tld_wcdpue_result->order_id, "_billing_last_name", true );

										//customer full name
										$tld_wcdpue_customer_full_name = $tld_wcdpue_customer_fname . ' ' . $tld_wcdpue_customer_lname;

										$tld_wcdpue_email_variables = array( "{account_url}", "{account_url_trim}", "{product_name}", "{product_url}", "{product_url_trim}", "{first_name}", "{last_name}", "{full_name}", "{download_url}", "{product_img}", "{download_name}" );

										$tld_wcdpue_email_variables_replace = array( $tld_wcdpue_account_url, $tld_wcdpue_account_url_trim, $tld_wcdpue_product_name, $tld_wcdpue_product_url, $tld_wcdpue_product_url_trim, $tld_wcdpue_customer_fname, $tld_wcdpue_customer_lname, $tld_wcdpue_customer_full_name, $tld_wcdpue_product_download_url, $tld_wcdpue_product_img, $tld_wcdpue_download_names );

										$tld_wcdpue_email_subject = str_replace( $tld_wcdpue_email_variables, $tld_wcdpue_email_variables_replace, $tld_wcdpue_email_subject );

										$tld_wcdpue_email_body = str_replace( $tld_wcdpue_email_variables, $tld_wcdpue_email_variables_replace, $tld_wcdpue_email_body );

										add_filter( 'wp_mail_content_type', 'tld_wcdpue_html_mail' );
										do_action( 'tld_wcdpue_send_email', $tld_wcdpue_email_address, $tld_wcdpue_email_subject, $tld_wcdpue_email_body, $tld_wcdpue_customer_full_name, $tld_wcdpue_product_name );

										remove_filter( 'wp_mail_content_type', 'tld_wcdpue_html_mail' );

									}

									$tld_wcdpue_no_spam[] = $tld_wcdpue_email_address;

								}
								//get our sent email count from tld_wcdpue_send_email()
								global $tld_wcdpue_emails_sent_count;

								setcookie( 'tld-wcdpue-num-emails-sent', $tld_wcdpue_emails_sent_count );

							}else{

								foreach ( $tld_wcdpue_query_result as $tld_wcdpue_result ){

									if( $tld_wcdpue_using_downloads_magictag == "on" ){

										$tld_wcdpue_email_address = $tld_wcdpue_result->user_email;

										//get user id via email
										$tld_wcdpue_customer_details = get_user_by( 'email', $tld_wcdpue_email_address );

										//empty the download link variable
										$tld_wcdpue_downloads_markup = '';

										$tld_wcdpue_download_names = '';
										//looping through selected products name
										foreach( $tld_wcdpue_updated_downloads_ids as $tld_wcdpue_updated_downloads_id ){

											//if user is registered
											if( ! empty( $tld_wcdpue_customer_details->ID ) && $tld_wcdpue_customer_details->ID !== 0 ){

												//get current user in loop available downloads
												$tld_wcdpue_customer_downloads = wc_get_customer_available_downloads( $tld_wcdpue_customer_details->ID );

												foreach ( $tld_wcdpue_customer_downloads as $download => $data ){

													//get the download link only for product names which were selected
													if ( $data["download_id"] == $tld_wcdpue_updated_downloads_id ){

														// TODO let users style their download button
														$tld_wcdpue_downloads_markup .= '<br/></br/><a href="' . $data["download_url"] . '">' . $data["download_name"] . '</a>' ;
														$tld_wcdpue_download_names .= ' ' . $data['download_name'];

													}

												}

											}else{


												$tld_wcdpue_product_downloads = $tld_wcdpue_product->get_downloads();

												//this is for guest download links
												foreach( $tld_wcdpue_product_downloads as $key => $download ) {

													if ( $download["id"] == $tld_wcdpue_updated_downloads_id ){

														// TODO let users style their download button
														$tld_wcdpue_downloads_markup .=  '<br/></br/><a href="'. site_url( '/?download_file=' . get_the_ID() . '&order=' . $tld_wcdpue_result->order_key . '&email='. $tld_wcdpue_email_address . '&key=' . $download['id'] ) .'">'. $download['name'] .'</a>';
														$tld_wcdpue_download_names .=  ' ' . $download['name'];

													}

												}

											}

										}

									}

									//check if an email has already been scheduled for this buyer, for this product.
									if( ! in_array( $tld_wcdpue_result->user_email, $tld_wcdpue_no_spam ) ){

										if( !isset( $tld_wcdpue_updated_downloads_ids ) && $tld_wcdpue_using_downloads_magictag == "on"){
											return;
										}

										$wpdb->insert(
											$tld_wcdpue_the_schedule_table,
											array(
												'product_id' 				=> $post_id,
												'order_id' 					=> $tld_wcdpue_result->order_id,
												'order_key'					=> $tld_wcdpue_result->order_key,
												'user_email' 				=> $tld_wcdpue_result->user_email,
												'downloads_markup' 	=> $tld_wcdpue_downloads_markup,
												'download_names' 		=> $tld_wcdpue_download_names
											)
										);
										$tld_wcdpue_emails_scheduled++;
									}
									//we're using user email here to prevent sending multiple emails
									$tld_wcdpue_no_spam[] = $tld_wcdpue_result->user_email;
								}

								//create amount of emails scheduled cookie for JS
								setcookie( "tld-wcdpue-emails-scheduled", $tld_wcdpue_emails_scheduled );

							}

						}

					}

					//delete our sending cookie since we're done with it
					setcookie( 'tld-wcdpue-cookie', 'tld-switch-cookie', time() - 3600 );

				}

				add_action( 'save_post_product', 'tld_wcdpue_post_saved' );
